diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ResponseTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ResponseTest.php
new file mode 100644
index 00000000..0e7eac93
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ResponseTest.php
@@ -0,0 +1,68 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha;
+
+class ResponseTest extends \PHPUnit_Framework_TestCase
+{
+
+    /**
+     * @dataProvider provideJson
+     */
+    public function testFromJson($json, $success, $errorCodes)
+    {
+        $response = Response::fromJson($json);
+        $this->assertEquals($success, $response->isSuccess());
+        $this->assertEquals($errorCodes, $response->getErrorCodes());
+    }
+
+    public function provideJson()
+    {
+        return array(
+            array('{"success": true}', true, array()),
+            array('{"success": false, "error-codes": ["test"]}', false, array('test')),
+            array('{"success": true, "error-codes": ["test"]}', true, array()),
+            array('{"success": false}', false, array()),
+            array('BAD JSON', false, array('invalid-json')),
+        );
+    }
+
+    public function testIsSuccess()
+    {
+        $response = new Response(true);
+        $this->assertTrue($response->isSuccess());
+
+        $response = new Response(false);
+        $this->assertFalse($response->isSuccess());
+    }
+
+    public function testGetErrorCodes()
+    {
+        $errorCodes = array('test');
+        $response = new Response(true, $errorCodes);
+        $this->assertEquals($errorCodes, $response->getErrorCodes());
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-widget-noscript.tpl.php b/drupal7/sites/all/modules/recaptcha/recaptcha-widget-noscript.tpl.php
new file mode 100644
index 00000000..dc542768
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-widget-noscript.tpl.php
@@ -0,0 +1,27 @@
+<?php
+
+/**
+ * @file recaptcha-widget-noscript.tpl.php
+ * Default theme implementation to present the reCAPTCHA noscript code.
+ *
+ * Available variables:
+ * - $sitekey: Google web service site key.
+ * - $language: Current site language code.
+ * - $url: Google web service API url.
+ *
+ * @see template_preprocess()
+ * @see template_preprocess_recaptcha_widget_noscript()
+ */
+?>
+<noscript>
+  <div style="width: 302px; height: 352px;">
+    <div style="width: 302px; height: 352px; position: relative;">
+      <div style="width: 302px; height: 352px; position: absolute;">
+        <iframe src="<?php print $url; ?>" frameborder="0" scrolling="no" style="width: 302px; height:352px; border-style: none;"></iframe>
+      </div>
+      <div style="width: 250px; height: 80px; position: absolute; border-style: none; bottom: 21px; left: 25px; margin: 0px; padding: 0px; right: 25px;">
+        <textarea id="g-recaptcha-response" name="g-recaptcha-response" class="g-recaptcha-response" style="width: 250px; height: 80px; border: 1px solid #c1c1c1; margin: 0px; padding: 0px; resize: none;" value=""></textarea>
+      </div>
+    </div>
+  </div>
+</noscript>
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha.admin.inc b/drupal7/sites/all/modules/recaptcha/recaptcha.admin.inc
index c0ecf912..bd2dc23a 100644
--- a/drupal7/sites/all/modules/recaptcha/recaptcha.admin.inc
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha.admin.inc
@@ -2,82 +2,83 @@
 
 /**
  * @file
- * Provides the reCAPTCHA administration settings.
+ * Provides the Google No CAPTCHA administration settings.
  */
 
 /**
- * Form callback; administrative settings for reCaptcha.
+ * Form callback; administrative settings for Google No CAPTCHA.
  */
 function recaptcha_admin_settings() {
-  // Load the recaptcha library. Error if library does not load.
-  if (!_recaptcha_load_library()) {
-    drupal_set_message(t('Error loading recaptchalib.'), 'error');
-    return FALSE;
-  }
-
-  $form = array();
-  $form['recaptcha_public_key'] = array(
+  $form['recaptcha_general_settings'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('General settings'),
+  );
+  $form['recaptcha_general_settings']['recaptcha_site_key'] = array(
     '#type' => 'textfield',
-    '#title' => t('Public Key'),
-    '#default_value' => variable_get('recaptcha_public_key', ''),
+    '#title' => t('Site key'),
+    '#default_value' => variable_get('recaptcha_site_key', ''),
     '#maxlength' => 40,
-    '#description' => t('The public key given to you when you <a href="@url" target="_blank">register for reCAPTCHA</a>.', array('@url' => url(recaptcha_get_signup_url($_SERVER['SERVER_NAME'], variable_get('site_name', ''))))),
+    '#description' => t('The site key given to you when you <a href="@url">register for reCAPTCHA</a>.', array('@url' => 'http://www.google.com/recaptcha/admin')),
     '#required' => TRUE,
   );
-  $form['recaptcha_private_key'] = array(
+  $form['recaptcha_general_settings']['recaptcha_secret_key'] = array(
     '#type' => 'textfield',
-    '#title' => t('Private Key'),
-    '#default_value' => variable_get('recaptcha_private_key', ''),
+    '#title' => t('Secret key'),
+    '#default_value' => variable_get('recaptcha_secret_key', ''),
     '#maxlength' => 40,
-    '#description' => t('The private key given to you when you <a href="@url" target="_blank">register for reCAPTCHA</a>.', array('@url' => url(recaptcha_get_signup_url($_SERVER['SERVER_NAME'], variable_get('site_name', ''))))),
+    '#description' => t('The secret key given to you when you <a href="@url">register for reCAPTCHA</a>.', array('@url' => 'http://www.google.com/recaptcha/admin')),
     '#required' => TRUE,
   );
-  $form['recaptcha_server_status_check_interval'] = array(
-    '#type' => 'textfield',
-    '#title' => t('Captcha server check interval'),
-    '#default_value' => variable_get('recaptcha_server_status_check_interval', 5),
-    '#description' => t('Number of minutes to cache reCAPTCHA server status.'),
-    '#size' => 10,
-  );
-  $form['recaptcha_ajax_api'] = array(
-    '#type' => 'checkbox',
-    '#title' => t('AJAX API'),
-    '#default_value' => variable_get('recaptcha_ajax_api', FALSE),
-    '#description' => t('Use the AJAX API to display reCAPTCHA.'),
-  );
-  $form['recaptcha_nocookies'] = array(
-    '#type' => 'checkbox',
-    '#title' => t('Disable Client-Side Cookies'),
-    '#default_value' => variable_get('recaptcha_nocookies', FALSE),
-    '#description' => t('Add flag to disable third-party cookies set by reCAPTCHA.'),
-  );
-  $form['recaptcha_theme_settings'] = array(
+
+  $form['recaptcha_widget_settings'] = array(
     '#type' => 'fieldset',
-    '#title' => t('Theme Settings'),
+    '#title' => t('Widget settings'),
     '#collapsible' => TRUE,
-    '#collapsed' => TRUE,
+    '#collapsed' => FALSE,
   );
-  $form['recaptcha_theme_settings']['recaptcha_theme'] = array(
+  $form['recaptcha_widget_settings']['recaptcha_theme'] = array(
     '#type' => 'select',
     '#title' => t('Theme'),
     '#description' => t('Defines which theme to use for reCAPTCHA.'),
     '#options' => array(
-      'red' => t('Red'),
-      'white' => t('White'),
-      'blackglass' => t('Black Glass'),
-      'clean' => t('Clean'),
-      'custom' => t('Custom'),
+      'light' => t('Light (default)'),
+      'dark' => t('Dark'),
     ),
-    '#default_value' => variable_get('recaptcha_theme', 'red'),
-    '#required' => TRUE,
+    '#default_value' => variable_get('recaptcha_theme', 'light'),
   );
-  $form['recaptcha_theme_settings']['recaptcha_tabindex'] = array(
+  $form['recaptcha_widget_settings']['recaptcha_type'] = array(
+    '#type' => 'select',
+    '#title' => t('Type'),
+    '#description' => t('The type of CAPTCHA to serve.'),
+    '#options' => array(
+      'image' => t('Image (default)'),
+      'audio' => t('Audio'),
+    ),
+    '#default_value' => variable_get('recaptcha_type', 'image'),
+  );
+  $form['recaptcha_widget_settings']['recaptcha_size'] = array(
+    '#default_value' => variable_get('recaptcha_size', ''),
+    '#description' => t('The size of CAPTCHA to serve.'),
+    '#options' => array(
+      '' => t('Normal (default)'),
+      'compact' => t('Compact'),
+    ),
+    '#title' => t('Size'),
+    '#type' => 'select',
+  );
+  $form['recaptcha_widget_settings']['recaptcha_tabindex'] = array(
     '#type' => 'textfield',
-    '#title' => t('Tab Index'),
-    '#description' => t('Sets a <a href="@tabindex" target="_blank">tabindex</a> for the reCAPTCHA text box. If other elements in the form use a tabindex, this should be set so that navigation is easier for the user.', array('@tabindex' => 'http://www.w3.org/TR/html4/interact/forms.html#adef-tabindex')),
-    '#default_value' => variable_get('recaptcha_tabindex', ''),
+    '#title' => t('Tabindex'),
+    '#description' => t('Set the <a href="@tabindex">tabindex</a> of the widget and challenge (Default = 0). If other elements in your page use tabindex, it should be set to make user navigation easier.', array('@tabindex' => 'http://www.w3.org/TR/html4/interact/forms.html#adef-tabindex')),
+    '#default_value' => variable_get('recaptcha_tabindex', 0),
     '#size' => 4,
   );
+  $form['recaptcha_widget_settings']['recaptcha_noscript'] = array(
+    '#type' => 'checkbox',
+    '#title' => t('Enable fallback for browsers with JavaScript disabled'),
+    '#default_value' => variable_get('recaptcha_noscript', 0),
+    '#description' => t('If JavaScript is a requirement for your site, you should <strong>not</strong> enable this feature. With this enabled, a compatibility layer will be added to the captcha to support non-js users.'),
+  );
 
   return system_settings_form($form);
 }
@@ -88,13 +89,8 @@ function recaptcha_admin_settings() {
  * @see recaptcha_admin_settings()
  */
 function recaptcha_admin_settings_validate($form, &$form_state) {
-  // Clear the page cache if Ajax API has been disabled.
-  if (empty($form_state['values']['recaptcha_ajax_api']) && $form['recaptcha_ajax_api']['#default_value']) {
-    cache_clear_all(NULL, 'cache_page');
-  }
-
   $tabindex = $form_state['values']['recaptcha_tabindex'];
-  if (!empty($tabindex) && !is_numeric($tabindex)) {
-    form_set_error('recaptcha_tabindex', t('The Tab Index must be an integer.'));
+  if (!is_numeric($tabindex)) {
+    form_set_error('recaptcha_tabindex', t('The tabindex must be an integer.'));
   }
 }
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha.info b/drupal7/sites/all/modules/recaptcha/recaptcha.info
index bb242b0d..608866b2 100644
--- a/drupal7/sites/all/modules/recaptcha/recaptcha.info
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha.info
@@ -1,16 +1,24 @@
 name = reCAPTCHA
-description = Uses the reCAPTCHA web service to improve the CAPTCHA system.
+description = Protect your website from spam and abuse while letting real people pass through with ease. 
 core = 7.x
 package = Spam control
 dependencies[] = captcha
-files[] = tests/recaptcha_base.test
-files[] = tests/recaptcha_ui.test
-files[] = tests/recaptcha_server_status.test
 configure = admin/config/people/captcha/recaptcha
+php = 5.3.2
 
-; Information added by Drupal.org packaging script on 2017-01-06
-version = "7.x-1.14"
+files[] = recaptcha.test
+files[] = recaptcha-php/src/ReCaptcha/ReCaptcha.php
+files[] = recaptcha-php/src/ReCaptcha/RequestMethod.php
+files[] = recaptcha-php/src/ReCaptcha/RequestParameters.php
+files[] = recaptcha-php/src/ReCaptcha/Response.php
+files[] = recaptcha-php/src/ReCaptcha/RequestMethod/Post.php
+files[] = recaptcha-php/src/ReCaptcha/RequestMethod/Socket.php
+files[] = recaptcha-php/src/ReCaptcha/RequestMethod/SocketPost.php
+files[] = src/ReCaptcha/RequestMethod/Drupal7Post.php
+
+; Information added by Drupal.org packaging script on 2016-07-23
+version = "7.x-2.2"
 core = "7.x"
 project = "recaptcha"
-datestamp = "1483730050"
+datestamp = "1469287440"
 
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha.install b/drupal7/sites/all/modules/recaptcha/recaptcha.install
index 8ce84be5..bd2cc6e0 100644
--- a/drupal7/sites/all/modules/recaptcha/recaptcha.install
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha.install
@@ -2,36 +2,102 @@
 
 /**
  * @file
- * Provides install, updated, and uninstall functions for recaptcha.
+ * Installation file for reCAPTCHA module.
  */
 
 /**
  * Implements hook_uninstall().
  */
 function recaptcha_uninstall() {
-  // Delete all the recaptcha variables and then clear the variable cache.
+  variable_del('recaptcha_site_key');
+  variable_del('recaptcha_secret_key');
+  variable_del('recaptcha_theme');
+  variable_del('recaptcha_type');
+  variable_del('recaptcha_size');
+  variable_del('recaptcha_tabindex');
+  variable_del('recaptcha_noscript');
+}
+
+/**
+ * Update variables from 7.x-1.x.
+ */
+function recaptcha_update_7200() {
+  // Migrate the public key to site key.
+  // Upgrade from 6.x-2.x to 7.x-2.x
+  $site_key = variable_get('recaptcha_site_key', '');
+  // Upgrade from 7.x-1.x to 7.x-2.x
+  $public_key = variable_get('recaptcha_public_key', $site_key);
+  variable_set('recaptcha_site_key', $public_key);
+  variable_del('recaptcha_public_key');
+
+  // Upgrade from 6.x-2.x to 7.x-2.x
+  $secret_key = variable_get('recaptcha_secret_key', '');
+  // Upgrade from 7.x-1.x to 7.x-2.x
+  $private_key = variable_get('recaptcha_private_key', $secret_key);
+  variable_set('recaptcha_secret_key', $private_key);
+  variable_del('recaptcha_private_key');
+
+  // Migrate previous 1.x themes to 2.x as good as possible.
+  $recaptcha_themes = array(
+    'red' => 'light',
+    'white' => 'light',
+    'blackglass' => 'dark',
+    'clean' => 'light',
+    'custom' => 'light',
+  );
+  // Upgrade from 6.x-2.x to 7.x-2.x
+  $recaptcha_themes += array(
+    'light' => 'light',
+    'dark' => 'dark',
+  );
+  $recaptcha_theme = variable_get('recaptcha_theme', 'light');
+  variable_set('recaptcha_theme', $recaptcha_themes[$recaptcha_theme]);
+
+  // Delete obsolete variables.
+  variable_del('recaptcha_ajax_api');
+  variable_del('recaptcha_nocookies');
+  variable_del('recaptcha_server_status_check_interval');
+
+  // Remove stale variables not cleaned up properly in previous releases.
+  variable_del('recaptcha_api_server');
+  variable_del('recaptcha_api_secure_server');
+  variable_del('recaptcha_secure_connection');
+  variable_del('recaptcha_verify_server');
+
+  // Mailhide module is not available, delete obsolete variables:
+  // - recaptcha_mailhide_public_key
+  // - recaptcha_mailhide_public_key_*
+  // - recaptcha_mailhide_private_key
+  // - recaptcha_mailhide_private_key_*
   db_delete('variable')
-    ->condition('name', 'recaptcha_%', 'LIKE')
+    ->condition('name', 'recaptcha_mailhide_%', 'LIKE')
     ->execute();
   cache_clear_all('variables', 'cache_bootstrap');
+
+  return t('Migrated settings. You may need to create a new site key and secret key if it does not work.');
 }
 
 /**
- * Implements hook_update_N().
+ * Default empty tabindex to 0.
  */
+function recaptcha_update_7201() {
+  // Change an empty tabindex to value 0 for consistency with D8.
+  $recaptcha_tabindex = variable_get('recaptcha_tabindex', '');
+  if ($recaptcha_tabindex == '') {
+    variable_set('recaptcha_tabindex', 0);
+  }
+
+  return t('Empty tabindex has been upgraded to 0.');
+}
 
 /**
- * Issue #2473329: Remove obsolete variables.
+ * Remove recaptcha_mailhide 7.x-1.x from system table.
  */
-function recaptcha_update_7100() {
-  $variables = array(
-    'recaptcha_secure_connection',
-    'recaptcha_api_server',
-    'recaptcha_api_secure_server',
-    'recaptcha_verify_server',
-  );
-  foreach ($variables as $variable) {
-    variable_del($variable);
-  }
-  return t('Removed obsolete variables.');
+function recaptcha_update_7202() {
+  // #2487215: Drupal 7.50+ requires system table cleanup.
+  db_delete('system')
+    ->condition('name', 'recaptcha_mailhide')
+    ->execute();
+
+  return t('Removed recaptcha_mailhide module from database.');
 }
